/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 188 by dpavlin, Tue Mar 16 22:00:20 2010 UTC revision 227 by dpavlin, Tue Sep 7 16:02:12 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    
44  lxc_status() {  lxc_status() {
45          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                  on_boot="       "                  boot="-"
47                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49          done                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52  }  }
53    
54    
# Line 53  cleanup_init_scripts() { Line 59  cleanup_init_scripts() {
59                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
60                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
61                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
62                    $rootfs/etc/rc?.d/*udev* \
63          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
64    
65            echo $1 > $rootfs/etc/hostname
66  }  }
67    
68    
# Line 64  setup_inittab() { Line 73  setup_inittab() {
73    
74          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
75          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
76          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
77                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
78                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
79                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 73  setup_inittab() { Line 82  setup_inittab() {
82  }  }
83    
84    
85    lxc_log() {
86            echo `date +%Y-%m-%dT%H:%M:%S` $*
87    }
88    
89    
90  lxc_kill() {  lxc_kill() {
91          name=$1          name=$1
92          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 96  lxc_kill() {
96                  lxc-info -n $name                  lxc-info -n $name
97                  exit 1                  exit 1
98          fi          fi
99          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
100          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
101  }  }
102    
103  lxc_stop() {  lxc_stop() {
104            lxc_log "$name stop"
105          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
106          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
107            lxc_log "$name stoped"
108  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
109  }  }
110    
111    
112  lxc_start() {  lxc_start() {
113          name=$1          name=$1
114            rootfs=$(lxc_rootfs $1)
115    
116            if [ ! -e $rootfs ] ; then
117                    echo "ERROR $name rootfs $rootfs not found"
118                    return
119            fi
120    
121          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
122                  echo "$name start"                  lxc_log "$name start"
123                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
124                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
125                  lxc-info  -n $name                  lxc-info  -n $name
# Line 105  lxc_start() { Line 127  lxc_start() {
127          fi          fi
128  }  }
129    
 lxc_log() {  
         echo `date +%Y-%m-%dT%H:%M:%S` $*  
 }  
   
130  lxc_watchdog() {  lxc_watchdog() {
131  name=$1  name=$1
132  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
# Line 152  while true; do Line 170  while true; do
170          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
171  done  done
172    
173  lxc_log "$name exited"  lxc_log "$name watchdog exited"
174    
175  }  }
176    
177    
178    usage() {
179            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
180            exit 3
181    }
182    
183  command_on_lxc() {  command_on_lxc() {
184  command=$1  command=$1
185  shift  shift
# Line 168  case "$command" in Line 191  case "$command" in
191  start)  start)
192          lxc_exists $1          lxc_exists $1
193          cleanup_init_scripts $1          cleanup_init_scripts $1
194          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
195          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
196            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
197          lxc_start $1          lxc_start $1
198          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
199          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 191  disable) Line 215  disable)
215          echo -n > /var/lib/lxc/$1/on_boot          echo -n > /var/lib/lxc/$1/on_boot
216          ;;          ;;
217  *)  *)
218          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
219          ;;          ;;
220    
221  esac  esac
# Line 200  esac Line 223  esac
223  }  }
224    
225  command=$1  command=$1
226    test -z "$command" && usage
227  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
228    shift
229    
230  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
231          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
232                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
233                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
234                            command_on_lxc $command $name
235                    else
236                            echo "# skip $command $name"
237                    fi
238          done          done
239  else  else
         shift  
240          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do
241                  command_on_lxc $command $1                  command_on_lxc $command $1
242                  shift                  shift

Legend:
Removed from v.188  
changed lines
  Added in v.227

  ViewVC Help
Powered by ViewVC 1.1.26